Package org.apache.lucene.codecs.perfield

# Class PerFieldKnnVectorsFormat.FieldsReader

java.lang.Object
org.apache.lucene.codecs.KnnVectorsReader
org.apache.lucene.codecs.perfield.PerFieldKnnVectorsFormat.FieldsReader

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

Enclosing class:
  `PerFieldKnnVectorsFormat`

public static class PerFieldKnnVectorsFormat.FieldsReader extends KnnVectorsReader
VectorReader that can wrap multiple delegate readers, selected by field.

## Constructor Summary

Constructors
Constructor
Description
`FieldsReader(SegmentReadState readState)`
Create a FieldsReader over a segment, opening VectorReaders for each KnnVectorsFormat specified by the indexed numeric vector fields.

## Method Summary

Modifier and Type
Method
Description
`void`
`checkIntegrity()`
Checks consistency of this reader.
`void`
`close()`
`ByteVectorValues`
`getByteVectorValues(String field)`
Returns the `ByteVectorValues` for the given `field`.
`KnnVectorsReader`
`getFieldReader(String field)`
Return the underlying VectorReader for the given field
`FloatVectorValues`
`getFloatVectorValues(String field)`
Returns the `FloatVectorValues` for the given `field`.
`void`
`search(String field, byte[] target, KnnCollector knnCollector, Bits acceptDocs)`
Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.
`void`
`search(String field, float[] target, KnnCollector knnCollector, Bits acceptDocs)`
Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.

### Methods inherited from class org.apache.lucene.codecs.KnnVectorsReader

`getMergeInstance`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### FieldsReader

public FieldsReader(SegmentReadState readState) throws IOException
Create a FieldsReader over a segment, opening VectorReaders for each KnnVectorsFormat specified by the indexed numeric vector fields.

Parameters:
  `readState` - defines the fields
Throws:
  `IOException` - if one of the delegate readers throws

## Method Details

### getFieldReader

public KnnVectorsReader getFieldReader(String field)
Return the underlying VectorReader for the given field

Parameters:
  `field` - the name of a numeric vector field

### checkIntegrity

public void checkIntegrity() throws IOException
Description copied from class: `KnnVectorsReader`
Checks consistency of this reader.

Note that this may be costly in terms of I/O, e.g. may involve computing a checksum value against large data files.

Specified by:
  `checkIntegrity` in class `KnnVectorsReader`
Throws:
  `IOException`

### getFloatVectorValues

public FloatVectorValues getFloatVectorValues(String field) throws IOException
Description copied from class: `KnnVectorsReader`
Returns the `FloatVectorValues` for the given `field`. The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

Specified by:
  `getFloatVectorValues` in class `KnnVectorsReader`
Throws:
  `IOException`

### getByteVectorValues

public ByteVectorValues getByteVectorValues(String field) throws IOException
Description copied from class: `KnnVectorsReader`
Returns the `ByteVectorValues` for the given `field`. The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

Specified by:
  `getByteVectorValues` in class `KnnVectorsReader`
Throws:
  `IOException`

### search

public void search(String field, float[] target, KnnCollector knnCollector, Bits acceptDocs) throws IOException
Description copied from class: `KnnVectorsReader`
Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

Specified by:
  `search` in class `KnnVectorsReader`
Parameters:
  `field` - the vector field to search
  `target` - the vector-valued query
  `knnCollector` - a KnnResults collector and relevant settings for gathering vector results
  `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
Throws:
  `IOException`

### search

public void search(String field, byte[] target, KnnCollector knnCollector, Bits acceptDocs) throws IOException
Description copied from class: `KnnVectorsReader`
Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

Specified by:
  `search` in class `KnnVectorsReader`
Parameters:
  `field` - the vector field to search
  `target` - the vector-valued query
  `knnCollector` - a KnnResults collector and relevant settings for gathering vector results
  `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
Throws:
  `IOException`

### close

public void close() throws IOException

Throws:
  `IOException`